/'
  <Slightly modified copy of the zlib license>
 
  cmnTTO_gState.bi -- Game state information.

  Copyright (C) 2008 Daniel Cousley

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Daniel Cousley
'/

#Ifndef CLTTO_GSTATE_BI_INCLUDED
#Define CLTTO_GSTATE_BI_INCLUDED
#Include "enet/enet.bi"

Enum e_gameState
	egsMainGame,
	egsWaiting,
	egsEndGame,
	egsResetGame
End Enum

Enum e_winner
	ewsDraw
	ewsP1Wins,
	ewsP2Wins,
End Enum

Enum e_keyState
	eksNone = 0,
	eksEscape,
	eksYes,
	eksNo
End Enum

Type t_ioState
	cellOffset As Ubyte
	mouseButton As UByte
	keyState As e_keyState
End Type

Type t_pState
	szName As String
	ioState As t_ioState
	ioStateChange As Integer
	cellState As UShort
	timeout As double
End Type

Type t_gameState
	host As EnetHost Ptr
	ip As String
	port As integer

	isRunning As Integer
	isServer As integer

	gState As e_gameState	
	wWinner As e_winner
	
	p1State As t_pState
	p2State As t_pState
	
	cellState As UShort
	turn As UByte
End Type


#EndIf
